/* Copyright (c) 2001-2004 by SoftIntegration, Inc. All Rights Reserved */
#include <stdarg.h>

void fun (int k, ...) {
    int i, j, ii, vacount;
    va_list ap;
    int *a;
    double *b;

    va_start(ap, k);
    vacount = va_count(ap);
    printf("vacount = %d\n", vacount);
    for(ii = 0; ii<vacount; ii++) {
      printf("va_dim(ap)= %d\n", va_dim(ap));
      i = va_extent(ap, 0);
      printf("va_extent(ap, 0)= %d\n", i);
      if(va_dim(ap) > 1) { 
        j = va_extent(ap, 1);
        printf("va_extent(ap, 1)= %d\n", j);
      }
      if(elementtype(int) == va_elementtype(ap)) {
        printf("array element is int\n");
        a = va_arg(ap, int*);
        printf("a = %p\n", a);
      }
      else if(elementtype(double) == va_elementtype(ap)) {
        printf("array element is double\n");
        b = va_arg(ap, double *);
        printf("b = %p\n", b);
      }
    }
    va_end(ap);
}

int main() {
   int i;
   int a[4]; 
   double b[5][6];

   fun(i, a);
   fun(i, b, a, 10);
}
